package velha;

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
import javax.swing.*;
import sun.rmi.registry.RegistryImpl;

public class Server {
	
	private ServerSocket server;
 	private Socket connection;
  	private String[] serverClientName;
	private ServerClient[] sClients;
	private DataInputStream input;
	private DataOutputStream output;
	private boolean isMain;
	private static boolean go;
	private boolean ready;
	private int clientsNumber;
//	private JFrame frame;
	private ServerInfo si;
	private boolean isFirstTime;
//	private VelhaServerImpl interServer;
		
	private int MAX_CLIENTS;

	private final int TIMEOUT = 1000;
	private final int PORT = 5050;

	public Server( String ip, int maxClients ){/*, JFrame fram ){*/ //ip = IP do servidor, se for o servidor principal, ip = null;
//		frame = fram;
		MAX_CLIENTS = maxClients;
		if ( ip == null ){
			isMain = true;
			clientsNumber = 0;
			serverClientName = new String[ MAX_CLIENTS ];
			sClients = new ServerClient[ MAX_CLIENTS ];
			si = new ServerInfo( serverClientName );
			try {
         		System.out.println( "IP: " + InetAddress.getLocalHost().toString() );
				server = new ServerSocket( PORT, MAX_CLIENTS );
        		}
			catch ( IOException ioe ){
				ioe.printStackTrace();
				System.exit( 1 );
			}
		}
		else {
			isMain = false;
			go = true;
			serverClientName = new String[ MAX_CLIENTS ];
			ip = ( ip.equals( "" ) ) ? "localhost" : ip;
			try {
				connection = new Socket( InetAddress.getByName( ip ), PORT );
				input = new DataInputStream( connection.getInputStream() );
				output = new DataOutputStream( connection.getOutputStream() );
			}
			catch ( IOException ioe ){
				ioe.printStackTrace();
				System.exit( 1 );
			}
			si = new ServerInfo( serverClientName );
			isFirstTime = true;
			runClient();
		}
	}
	
	public void runServer(){
		System.out.println( "Servidor principal rodando" );
		System.out.println( "Aguardando " + MAX_CLIENTS + " conexao(oes) para iniciar" );
		for ( int i = 0; i < MAX_CLIENTS; i++ ){
			addServerClient( i );
			if (( MAX_CLIENTS - clientsNumber ) != 0 ){
				System.out.println( "Aguardando " + (MAX_CLIENTS - clientsNumber) + " conexao(oes) para iniciar" );
			}
		}
		interServerInit();
		System.out.println( "Inicializando os servidores" );
		for ( int i = 0; i < clientsNumber; i++ ){
			sClients[ i ].start();
		}
		System.out.println( "Servidores inicializados" );
		si.show();
	}
	
	// Este mtodo  synchronized porque altera tanto o Vector de 
	// ServerClient, quanto a quantidade de ServerClient
	
	private synchronized void addServerClient( int i ){
		try {
			Socket newSocket = server.accept();
			ServerClient newSC = new ServerClient( newSocket, i, this );
			String hostName = newSocket.getInetAddress().toString();
			serverClientName[ clientsNumber ] = hostName;
			sClients[ clientsNumber ] = newSC;
			clientsNumber++;
			System.out.println( "Conexao recebida de: " + hostName );
			si.setList( serverClientName );
		}
		catch ( IOException ioe ){
			ioe.printStackTrace();
			System.exit( 1 );
		}
	}

	private synchronized void removeServerClient( int index ){
		sClients[ index ] = sClients[ clientsNumber - 1 ];
		sClients[ index ].setMainServerPosition( index );
		sClients[ clientsNumber - 1 ] = null;
		serverClientName[ index ] = serverClientName[ clientsNumber - 1 ];
		serverClientName[ clientsNumber - 1 ] = null;
		clientsNumber--;
		si.setList( serverClientName );
		addServerClient( clientsNumber );
	}
	
	public void sendStrings( int index ){
		ServerClient sc = sClients[ index ];
		String name;
		for (int i = 0; i < clientsNumber; i++){
			name = serverClientName[ i ];
			sc.sendString( name );
		}
		sc.sendString( "Over" );
		sc.flush();
	}
	
	public void receiveStrings(){
		String[] newServerName = new String[ MAX_CLIENTS ];
		try {
			String current = input.readUTF();
			int i = 0;
			while ( ! current.equals( "Over" ) ){
				newServerName[ i ] = current;
				current = input.readUTF();
				i++;
			}
//			if ( !serverClientName.equals( newServerName ) ){
				serverClientName = newServerName;
//				si.setList( serverClientName );
//			}
		}
		catch ( SocketException se ){
			System.err.println( "Servidor nao encontrado, procurando novo servidor" );
			tryForMainServer( true, 0 );
		}
		catch ( IOException ioe ){
			ioe.printStackTrace();
			System.exit( 1 );
		}
	}
	
	public String sub( String ip ){
	       int ipBarra = ip.indexOf( '/' ) + 1;
//             System.out.println( ip.substring(ipBarra) );
	       return ip.substring( ipBarra );
	}

	public synchronized void tryForMainServer( boolean firstTime, int index ){
		String first = serverClientName[ index ];
        String temp = connection.getInetAddress().toString();
		if ( ( first == null ) || ( sub(first).equals(sub(temp)) ) ){
			isMain = true;
			runClientStop();
//			clientsNumber = serverClientName.length - 1;
			sClients = new ServerClient[ MAX_CLIENTS ];
//			Thread.currentThread().setPriority( Thread.NORM_PRIORITY );
			try {
				server = new ServerSocket( PORT, MAX_CLIENTS );
			}
			catch ( IOException ioe ){
				ioe.printStackTrace();
				System.exit( 1 );
			}
			runServer();
		}
		else {
			try {
				connection = new Socket( first, PORT );
				input = new DataInputStream( connection.getInputStream() );
				output = new DataOutputStream( connection.getOutputStream() );
				runClientStop(); //para a execuao de runClient() e de run()
				runClient();
			}
			catch ( IOException ioe ){
				if ( firstTime ){
					try {
						wait( TIMEOUT * 4 ); //dando tempo ao servidor da vez de ceder a conexao
					}
					catch ( InterruptedException ie){
						ie.printStackTrace();
						System.exit( 1 );
					}
					tryForMainServer( false, index );
				}
				else {
					tryForMainServer( true, index + 1 );
				}
			}
		}
	}
	
/*	public void run(){
		while( go ){
			try {
				Thread current = Thread.currentThread();
				SwingUtilities.invokeLater( new ListUpdate( current ) );
				if(isFirstTime){
					System.out.println("Aguarde enquanto a lista de servidores e criada");
					System.out.println("Esta operacao leva alguns segundos.");
				}
				ready = false;
				while(!ready){
				}
			}
//			catch ( InterruptedException ie ){
//				System.out.print( "0" );
//				continue;
//			}
			catch ( Exception e ){
				e.printStackTrace();
				System.exit( 1 );
			}
		}		
	}*/
		
	public void runClient(){
		System.out.println( "Servidor conectado" );
//		Thread.currentThread().setPriority( Thread.MIN_PRIORITY );
//		Thread refresher = new Thread( this );
//		refresher.start();
//		si.show();
		while( go ){
			try {
//				Thread.yield();
				receiveStrings();
/*				Thread current = Thread.currentThread();
				SwingUtilities.invokeLater( new ListUpdate( current ) );
				if(isFirstTime){
					System.out.println("Aguarde enquanto a lista de servidores e criada");
					System.out.println("Esta operacao leva alguns segundos.");
				}
				ready = false;
				while(!ready){
					current.sleep(1000);
					System.out.print( "1" );
				}
			}
			catch ( InterruptedException ie ){
				System.out.print( "0" );
				continue;
*/			}
			catch ( Exception e ){
				e.printStackTrace();
				System.exit( 1 );
			}
		}
	}

	public void runClientStop(){
		go = false;
	}

	public void interServerInit(){
		try{
          System.err.println("Inicializando servidor de jogo\nPor Favor Aguarde.");
          VelhaServerImpl servidor = new VelhaServerImpl();
          RegistryImpl r = new RegistryImpl(1099);
          Naming.rebind("//localhost/VelhaServer", servidor);
          System.err.println("O servidor de jogo esta rodando.");
		}
		catch ( Exception e ){
		}
	}
	
	private class ServerClient extends Thread {
		private Server mainServer;
		private Socket connection;
		private DataInputStream input;
		private DataOutputStream output;
		private String serverName;
		private int mainServerPosition;
		private boolean keep;
		
		public ServerClient( Socket socket, int number, Server mnSrv ){
			mainServer = mnSrv;
			connection = socket;
			mainServerPosition = number;
			keep = true;
			try {
				input = new DataInputStream( connection.getInputStream() );
				output = new DataOutputStream( connection.getOutputStream() );
			}
			catch ( Exception e ){
				e.printStackTrace();
				System.exit( 1 );
			}
		}
		
		public void run(){
			while( keep ){
				mainServer.sendStrings( mainServerPosition );
			}
		}
		
		public void setMainServerPosition( int number ){
			mainServerPosition = number;
		}

		public void destroy(){
			keep = false;
			System.out.println( "Removendo Cliente Inativo" );
			System.out.println( "Aguardando Nova Conexao..." );
			mainServer.removeServerClient( mainServerPosition );
		}
		
		public void sendString( String stg ){
			try {
				output.writeUTF( stg );
			}
			catch ( SocketException se ){
				this.destroy();
			}
			catch ( IOException ioe ){
				ioe.printStackTrace();
				System.exit( 1 );
			}
		}
		
		public void flush(){
			try {
				output.flush();
			}
			catch ( SocketException se ){
				this.destroy();
			}
			catch ( IOException ioe ){
				ioe.printStackTrace();
				System.exit( 1 );
			}
		}
	}
	
/*	private class ListUpdate extends Thread {
		private Thread caller;
		
		public ListUpdate( Thread t ){
			super( "ListUpdate" );
			caller = t;
		}
				
		public void run(){
			si.setList( serverClientName );
			if(isFirstTime){
				System.out.println( "Concluido." );
				si.show();
				isFirstTime = false;				
			}
			ready = true;
			caller.interrupt();
		}
	}*/
}
