package velha;

import java.net.*;
import java.io.*;
import java.io.IOException;
import java.io.Serializable;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Jogador implements Serializable{

  private String nome;
  private int meuSimbolo;
  private int simboloInimigo;
  private boolean podeJogar;
  private int pontos;
  private int vitorias;
  private int empates;
  private int jogos;

  private Socket cliente;
  private ServerSocket servidor;
  private OutputStream out;
  private InputStream in;
  private InetAddress host;
  private Tabuleiro tabuleiro;

  public Jogador(String n) throws UnknownHostException {
    setNome(n);
    this.pontos = 0;
    this.vitorias = 0;
    this.empates = 0;
    this.jogos = 0;
    host = host.getLocalHost();
  }

  public void setNome(String n) {
    if (n != null) {
      nome = n;
    }
  }

  public String getNome() {
    return nome;
  }

  public int getPontos() {
    return this.pontos;
  }

  public int getVitorias() {
    return this.vitorias;
  }

  public int getEmpates() {
    return this.empates;
  }

  public int getJogos() {
    return this.jogos;
  }

  public Tabuleiro getTabuleiro(){
      return this.tabuleiro;
  }

  public void setJogos() {
    this.jogos = this.jogos + 1;
  }

  public void setVitorias() {
    this.vitorias = this.vitorias + 1;
  }

  public void setEmpates() {
    this.empates = this.empates + 1;
  }

  public void setPontos() {
    this.pontos = (5 * (this.getVitorias())) + (2 * this.getEmpates()) +
        this.pontos;
    this.pontos = this.pontos -
        ( (this.getJogos() - (this.getVitorias() + this.getEmpates())) * 2);
  }

  public int getSimbolo() {
    return meuSimbolo;
  }

  public void setPodeJogar(boolean b) {
    podeJogar = b;
  }

  public boolean getPodejogar() {
    return podeJogar;
  }

  /**
   *Mtodo que solicita um jogo. no importa o jogador a quem ele solicita.
   *o que ele faz  abrir um servidor e escutar a porta ate que alguem
   *conecte. Para quem solicita o simbolo  X(1). e ele comea jogando.   *
   */

  public void requisitarJogo() throws IOException {
    servidor = new ServerSocket(5000);
    servidor.setSoTimeout(20000); //espera 20 segundos por uma conexao
    cliente = servidor.accept();
    iniciarStreams();
    meuSimbolo = 1;
    simboloInimigo = 2;
    tabuleiro = new Tabuleiro();
    podeJogar = true;
  }

  /**
   * Mtodo que aceita um jogo. Abre uma conexao com o host que solicitou o
   * jogo, pegando-se o jogador que foi passado como parametro e obtendo seu
   * host. o smbolo para quem aceita o jogo  a bola(2). e ele  o segundo
   * a jogar.
   * @param remoto O jogador remoto.
   *
   */

  public void aceitarJogo(Jogador remoto) throws IOException {
    cliente = new Socket(remoto.host, 5000);
    iniciarStreams();
    meuSimbolo = 2;
    simboloInimigo = 1;
    Jogo jogo = new Jogo(null,this,remoto);
    tabuleiro = new Tabuleiro();
    podeJogar = false;

  }

  private void iniciarStreams() throws IOException {

    in = cliente.getInputStream();
    out = cliente.getOutputStream();

  }

  public boolean escrever(int i) throws IOException, CelulaCheiaException {
    out.write(i);
    out.flush();
    tabuleiro.incremetarJogada();
    boolean venceu = tabuleiro.marcarCelula(i, meuSimbolo);
    podeJogar = false;

    return venceu;
  }

  /**
   * le a posicao a ser marcada pelo adversrio. nunca vai disparar a
   * exception, ja que ela  obtida mediante o mtodo escrever() do
   * adversario.
   */
  public int ler() throws IOException, CelulaCheiaException {
    int posicao = in.read();
    boolean venceu = tabuleiro.marcarCelula(posicao, simboloInimigo);
    tabuleiro.incremetarJogada();
    podeJogar = true;
    return posicao;
  }

  /**
   * mtodo a ser utilizado quando o jogo acaba.
   */
  public void fecharTudo() throws IOException {

    cliente.close();
    servidor.close();
    out.close();
    in.close();

  }

}
