package velha;

import java.io.Serializable;
/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Infra-Estrutura de Software
 * Projeto: Jogo da Velha
 *
 * Tipo:     Players
 * Alunos: Everson Luis da Silva Melo (elsm2@cin.ufpe.br)
 *         Lamberto Augusto de Oliveira Neto (laon@cin.ufpe.br)
 *         Millena de Andrade Almeida Gomes (maag@cin.ufpe.br)
 *         Pablo Arajo Borges (pab@cin.ufpe.br)
 */

 public class Players implements Serializable{

      private String nick;
      private String servidor;
      private Jogador jogador;

      public Players(String n, String s){
          nick = n;
          servidor= s;
      }

      public Players(Jogador n, String s){
          nick = n.getNome();
          servidor= s;
          jogador = n;
      }

      public Players(){
        nick = "";
        servidor = "";
      }

      public String getNick(){
          return this.nick;
      }

      public String getServidor(){
          return this.servidor;
      }

      public void setNick(String nc){
        try{
          this.nick = nc;
          this.jogador = new Jogador(nc);
        }catch(Exception ex){
            ex.printStackTrace();
        }
      }

      public Jogador getJogador(){
          return this.jogador;
      }

      public void setServidor(String sv){
          this.servidor = sv;
      }

      public boolean equals(Players ver){
        boolean retorno = true;
        if(!ver.getNick().equals(this.nick)){
          retorno = false;
        }
        return retorno;
      }
 }
